/*
 *
 * Copyright (C) 2004 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Loic Dachary <loic@gnu.org>
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <iostream>
#include <fstream>

#include <exg/exg.h>

static char mesh_load_doc[] =
"load exg mesh\n"
"\n";

static PyObject *
mesh_load(PyObject* dummy, PyObject *args)
{
  char* path = 0;

  if(!PyArg_ParseTuple(args, "s:load", &path))
    return NULL;

  std::ifstream in(path, std::ios_base::binary);
  exg::Pointer<exg::Mesh> object=0;
  exg::IOContext context;
  exg::Load(object, in, &context);
  //  exg::Repair(object.Get(), &context);
  return Object2PyObject(object.Get());
}

static char mesh_save_doc[] =
"save exg mesh\n"
"\n";

static PyObject *
mesh_save(PyObject* dummy, PyObject *args)
{
  char* path = 0;
  PyObject* pymesh;
  exg::Pointer<exg::Object>* pointer = 0;

  if(!PyArg_ParseTuple(args, "Os:save", &pymesh, &path))
    return NULL;

  pointer = (exg::Pointer<exg::Object>*)PyCObject_AsVoidPtr(pymesh);

  std::ofstream out(path, std::ios_base::binary);
  exg::Save(pointer->Get(), out);

  Py_INCREF(Py_None);
  return Py_None;
}

static PyMethodDef mesh_functions[] = {
  {"load", (PyCFunction)mesh_load, METH_VARARGS, mesh_load_doc},
  {"save", (PyCFunction)mesh_save, METH_VARARGS, mesh_save_doc},
  {NULL,	NULL}		/* sentinel */
};

PyMODINIT_FUNC
initmesh(void)
{
  PyObject *module;

  if((module = Py_InitModule("mesh", mesh_functions)) == NULL) {
    /* error */
    return;
  }
}
